var lWarn = {logln:function (o){}};
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sr-config.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
}

function startup() {
    // Prepare app
    Property.load();
    var version = '1.0.3',
        propVersion = Property.getNode('version');
    lInfo.logln("startup scene-responder");

    if (propVersion) {
        var currentVersion = propVersion.getValue();
        if (isPropertyTreeNotCurrent(currentVersion, '0.4')) {
            lInfo.logln("Converting from version " + currentVersion + " to 0.4");
            convertOldTriggers();
            currentVersion = '0.4';
        }
        if (isPropertyTreeNotCurrent(currentVersion, version)) {
            lInfo.logln("Converting from version " + currentVersion + " to " + version);
            updateData();
        }
    }
    updateAllTrigger();

    if (!Property.getNode('entries')) {
        var nd = new Property('entries');
        nd.setFlag('ARCHIVE', true);
    }
    //set version number
    Property.setProperty('version', version);
    Property.setFlag('version', 'ARCHIVE', true);
    Property.store();
    lInfo.logln("scene-responder running (Version " + version + ")");
}

function storeSubParameter(path, value) {
    Property.setProperty('entries/' + path, value);
    Property.setFlag('entries/' + path, 'ARCHIVE', true);
}

function putConditionParameter(idValue,oParameterObject) {
	if (oParameterObject.conditions==null)
		return;
	var sSubpath=idValue + '/conditions/';
	if (oParameterObject.conditions.enabled!=null) {
		if (oParameterObject.conditions.enabled==true)
			storeSubParameter(sSubpath + 'enabled', true);
		else 
			storeSubParameter(sSubpath + 'enabled', false);
	}	
	if (oParameterObject.conditions.weekdays!=null) {
		var sString="";
		for (var iIndex=0;iIndex<oParameterObject.conditions.weekdays.length;iIndex++) {
			var sWeekday=oParameterObject.conditions.weekdays[iIndex];
			switch (sWeekday)
			{
				case 'SU':
					sString += '0,'
				break;
				case 'MO':
					sString += '1,'
				break;
				case 'TU':
					sString += '2,'
				break;
				case 'WE':
					sString += '3,'
				break;
				case 'TH':
					sString += '4,'
				break;
				case 'FR':
					sString += '5,'
				break;
				case 'SA':
					sString += '6,'
				break;
			}	
		}
		if (sString!="") {
			sString=sString.substr(0,sString.length-1);
			storeSubParameter(sSubpath + 'weekdays', sString);
		}
	}	
	if (oParameterObject.conditions.systemState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.systemState.length;iIndex++){
			var sStateName=oParameterObject.conditions.systemState[iIndex].name;
			var sStateValue=oParameterObject.conditions.systemState[iIndex].value;
			if (sStateValue==='false')
				sStateValue=false;
			if (sStateValue==='true')
				sStateValue=true;
			storeSubParameter(sSubpath + 'states/' + sStateName,sStateValue)
		}
	}	
	if (oParameterObject.conditions.zoneState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.zoneState.length;iIndex++){ 
			var zoneID=oParameterObject.conditions.zoneState[iIndex].zone;
			var groupID=oParameterObject.conditions.zoneState[iIndex].group;
			var sceneID=oParameterObject.conditions.zoneState[iIndex].scene;
			
			storeSubParameter(sSubpath + 'zone-states/' + iIndex + '/zone' , zoneID);
			storeSubParameter(sSubpath + 'zone-states/' + iIndex + '/group' , groupID);
			storeSubParameter(sSubpath + 'zone-states/' + iIndex + '/scene' , sceneID);
		}
	}	
	if (oParameterObject.conditions.timeframe!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.timeframe.length;iIndex++){ 
			var from=oParameterObject.conditions.timeframe[iIndex].start;
			var to=oParameterObject.conditions.timeframe[iIndex].end;
			var sFromBase=from.timeBase;
			var sFromOffset=from.offset;
			var sToBase=to.timeBase;
			var sToOffset=to.offset;
			lInfo.logln('from ' + sFromBase + ' off ' + sFromOffset + ' to  ' + sToBase + ' off ' + sToOffset);
			if (sFromBase=='daily')
				if (sToBase=='daily'){
					storeSubParameter(sSubpath + 'time-start' , Math.floor(parseInt("" + sFromOffset,10)/3600) + ':' + Math.floor(parseInt("" + sFromOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sFromOffset,10)%60));
					storeSubParameter(sSubpath + 'time-end'  , Math.floor(parseInt("" + sToOffset,10)/3600) + ':' + Math.floor(parseInt("" + sToOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sToOffset,10)%60));
				}
		}	
	}		
}

function putTriggerParameter(idValue,oParameterObject) {
    for (var iIndex=0;iIndex<oParameterObject.triggers.length;iIndex++)
    {
        var sSubpath=idValue + '/triggers/' + (iIndex + 1) + "/";
        storeSubParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type);
        switch(oParameterObject.triggers[iIndex].type) {
            case 'zone-scene':
                storeSubParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone);
                storeSubParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group);
                storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
                storeSubParameter(sSubpath + "dsid" , -1);
                break;
            case 'undo-zone-scene':
                storeSubParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone);
                storeSubParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group);
                storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
                storeSubParameter(sSubpath + "dsid" , -1);
                break;
            case 'device-msg':
                storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
                storeSubParameter(sSubpath + "msg" , oParameterObject.triggers[iIndex].msg);
                if (oParameterObject.triggers[iIndex].buttonIndex!=null)
                    storeSubParameter(sSubpath + "buttonIndex" , oParameterObject.triggers[iIndex].buttonIndex);
                break
            case 'device-binary-input':
                storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
                storeSubParameter(sSubpath + "index" , oParameterObject.triggers[iIndex].index);
                storeSubParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state);
                break
            case 'device-scene':
                storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
                storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
                break;
            case 'custom-event':
                storeSubParameter(sSubpath + "event" , oParameterObject.triggers[iIndex].event);
                break;
            case 'device-sensor':
                storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
                storeSubParameter(sSubpath + "eventid" , oParameterObject.triggers[iIndex].eventid);
                break;
        }
    }

}

function putActionParameter(idValue,oParameterObject) {
    for ( var iIndex = 0; iIndex < oParameterObject.actions.length; iIndex++) {
        var oSubobject = oParameterObject.actions[iIndex];
        storeSubParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type);
        switch (oSubobject.type) {
            case 'zone-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'undo-zone-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'device-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'device-value':
                storeSubParameter(idValue + '/actions/' + iIndex + '/value', oSubobject.value);
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
            break;
            case 'device-blink':
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
            break;
            case 'zone-blink':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
            break;
            case 'custom-event':
                storeSubParameter(idValue + '/actions/' + iIndex + '/event', oSubobject.event);
            break;
            case 'url':
                storeSubParameter(idValue + '/actions/' + iIndex + '/url', oSubobject.url);
            break;
        }
        if (oSubobject.delay!=null) {
            storeSubParameter(idValue + '/actions/' + iIndex + '/delay', oSubobject.delay);
        }
    }
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null) {
        return idValue;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null) {
            if (oChildNode.getChild('id').getValue() != null) {
                if (parseInt("" + oChildNode.getChild('id').getValue(), 10) >= idValue) {
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(), 10) + 1;
                }
            }
        }
    }
    return idValue;
}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        if (oParameterObject.id != null) {
            idValue = oParameterObject.id;
        } else {
            idValue = getNewIdValue();
        }

        var baseNode = Property.getNode('entries');
        if (baseNode != null) {
            baseNode.removeChild(idValue);
        }

        storeSubParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(idValue + '/id', idValue);
        storeSubParameter(idValue + '/conditions/enabled', true);

        putActionParameter(idValue,oParameterObject);
        putTriggerParameter(idValue,oParameterObject);
        putConditionParameter(idValue,oParameterObject);
        storeSubParameter(idValue + '/delay', oParameterObject.delay);
        
        storeSubParameter(idValue + '/doubleChecked', false);
        if (oParameterObject.doubleChecked!=null)
            if (oParameterObject.doubleChecked) { 
                storeSubParameter(idValue + '/doubleChecked', true);
                lInfo.logln("SR-Config: double checked!");
                for (var kIndex=0;kIndex<oParameterObject.triggers.length;kIndex++) {
                    if (oParameterObject.triggers[kIndex].type=='zone-scene') {
                        putConditionParameter(idValue,{conditions:[{type:'zone-states',value:[{zone:oParameterObject.triggers[0].zone,group:oParameterObject.triggers[0].group,scene:oParameterObject.triggers[0].scene}]}]});
                    }
                }
                
            }
        
        storeSubParameter(idValue + '/singularTriggered', false);
        if (oParameterObject.singularTriggered!=null)
            if (oParameterObject.singularTriggered)
                    storeSubParameter(idValue + '/singularTriggered', true);
        storeSubParameter(idValue + '/initialTriggered', false);
        if (oParameterObject.initialTriggered!=null)
            if (oParameterObject.initialTriggered)
                    storeSubParameter(idValue + '/initialTriggered', true);
        Property.store();
        updateTriggerRegistration(Property.getNode('entries/' + idValue));
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    }
}

function updateAllTrigger()
{
    var baseNode = Property.getNode('entries');
    if (baseNode == null) {
        lInfo.logln("SR-Config update all trigger : no entries");
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("SR-Config Set Trigger" + iIndex);
        var oChildNode = oArrayNode[iIndex];
        updateTriggerRegistration(oChildNode);
    }
}

function updateTriggerRegistration(oChildNode)
{
    var oParameter={};
    try {
        if (oChildNode.getChild('singularTriggered')!=null)
            if (oChildNode.getChild('singularTriggered').getValue()) {
                registerTrigger(oChildNode.getPath(),'system-addon-scene-responder.delayedTrigger',oParameter);
                return;
            }
        if (oChildNode.getChild('initialTriggered')!=null)
            if (oChildNode.getChild('initialTriggered').getValue()) {
                registerTrigger(oChildNode.getPath(),'system-addon-scene-responder.initialTrigger',oParameter);
                return;
            }
        if (oChildNode.getChild("delay")!=null) 
            if (oChildNode.getChild("delay").getValue()!=0){
                oParameter.time = "+" + oChildNode.getChild("delay").getValue();
            }
        
        registerTrigger(oChildNode.getPath(),'action_execute',oParameter);
    } catch (e) {
        lWarn.logln("Fehler beim registerTrigger: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    } 
}

if (raisedEvent.name == 'system-addon-scene-responder.config') {
	Property.load();
    lInfo.logln("SR-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("SR-Config param value " + unescape(raisedEvent.parameter.value));
        storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("SR-Config enable value " + raisedEvent.parameter.id);

        var sanityCheck = Property.getNode('entries/'+raisedEvent.parameter.id);
        if (sanityCheck != null) {                
            storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', true);
        }
        
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("SR-Config disable value " + raisedEvent.parameter.id);
        
        var sanityCheck = Property.getNode('entries/'+raisedEvent.parameter.id);
        if (sanityCheck != null) {                
            storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', false);
        }
        
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("SR-Config delete value " + raisedEvent.parameter.id);

        var baseNode = Property.getNode('entries');
        if (baseNode != null) {
            baseNode.removeChild(raisedEvent.parameter.id);
            unregisterTrigger(baseNode.getPath() + "/" + raisedEvent.parameter.id);
        }

        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
} else if (raisedEvent.name == 'running') {
    startup();
}

